hdu 3829 Cat VS Dog (2分匹配 求 最大独立集)

hdu 3829 Cat VS Dog (二分匹配 求 最大独立集)

Cat VS Dog

                                                                             Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 125536/65536 K (Java/Others)

Problem Description
The zoo have N cats and M dogs, today there are P children visiting the zoo, each child has a like-animal and a dislike-animal, if the child's like-animal is a cat, then his/hers dislike-animal must be a dog, and vice versa.
Now the zoo administrator is removing some animals, if one child's like-animal is not removed and his/hers dislike-animal is removed, he/she will be happy. So the administrator wants to know which animals he should remove to make maximum number of happy children.
 

Input
The input file contains multiple test cases, for each case, the first line contains three integers N <= 100, M <= 100 and P <= 500.
Next P lines, each line contains a child's like-animal and dislike-animal, C for cat and D for dog. (See sample for details)
 

Output
For each case, output a single integer: the maximum number of happy children.
 

Sample Input
1 1 2 C1 D1 D1 C1 1 2 4 C1 D1 C1 D1 C1 D2 D2 C1
 

Sample Output
1 3
Hint
Case 2: Remove D1 and D2, that makes child 1, 2, 3 happy.
 
题意:有p个孩子参观动物园,动物园里面有n只猫和m只狗,每个孩子喜欢猫讨厌狗,或者喜欢狗讨厌猫。只有把一个孩子不喜欢的动物移走,喜欢的动物留下,这个孩子才会高兴。 问最多能使多少个孩子高兴。

分析:如果A、B两个孩子都高兴,则说明他们之间没有矛盾,即A喜欢的动物不是B不喜欢的动物,A不喜欢的动物也不是B喜欢的动物,那么就可以认为A、B是独立的。所以问题就是求最大独立集。而最大独立集=节点总个数-最小覆盖集,最小覆盖集=最大匹配,所以最大独立集=节点总个数-最大匹配。问题转化为了求最大匹配。
     可是如果按照cat和dog的最大匹配来做的话,怎么建图呢?因此我们不这样做。
     如果A喜欢的动物是B不喜欢的动物,或者A不喜欢的动物是B喜欢的动物,那么A、B之间就产生了矛盾,我们就在A和B之间建立一条边,然后求出最多有多少对孩子之间产生矛盾,用这个结果除以2就是最大匹配数。
#include<stdio.h>
#include<string.h>
#include<vector>
#include<algorithm>
using namespace std;

const int N = 505;
vector<int> vec[N];
char like[N][10], dislike[N][10];
int flag[N], vis[N];

bool dfs(int a)
{
    int i;
    for(i = 0; i < vec[a].size(); i++)
    {
        int u = vec[a][i];
        if(!vis[u])
        {
            vis[u] = 1;
            if(!flag[u] || dfs(flag[u]))
            {
                flag[u] = a;
                return true;
            }
        }
    }
    return false;
}

int hungary(int n) //匈牙利算法求最大匹配
{
    int cnt = 0;
    for(int i = 0; i < n; i++)
    {
        memset(vis, 0, sizeof(vis));
        if(dfs(i))
            cnt++;
    }
    return cnt;
}

int main()
{
    int i, j, n, m, p;
    while(~scanf("%d%d%d",&n,&m,&p))
    {
        memset(vec, 0, sizeof(vec));
        memset(flag, 0, sizeof(flag));
        for(i = 0; i < p; i++)
            scanf("%s%s",like[i], dislike[i]);
        for(i = 0; i < p; i++)
            for(j = i + 1; j < p; j++)
            {
                if(!strcmp(like[i], dislike[j]) || !strcmp(dislike[i], like[j]))
                {   // i和j产生矛盾时就在i和j之间建立一条边
                    vec[i].push_back(j);
                    vec[j].push_back(i);
                }
            }
        int k = hungary(p);
        printf("%d\n",p - k/2);
    }
    return 0;
}